﻿//
// Copyright (c) 2015, MindFusion LLC - Bulgaria.
//

using System;
using System.Windows;
using System.Windows.Input;
using System.Windows.Media;


namespace MindFusion.Scheduling.Wpf.Samples.CS.CustomTimetableGrid
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		public MainWindow()
		{
			InitializeComponent();

			calendar.Date = new DateTime(DateTime.Now.Year, DateTime.Now.Month, 1);
			calendar.AllowInplaceCreate = false;
			calendar.AllowInplaceEdit = false;
			calendar.ItemStartModifying += (s, e) => e.Confirm = false;

			CustomItem item;

			item = new CustomItem()
			{
				Auth = Colors.Red,
				Site = "C017",
				Patient = "Bellic, Nikko",
				Drug = "Zosyn 4.5g q6h x6 days thru 11/24",
				Qty = 24,
				Type = DataType.ChangeRx,
				Status = DataStatus.Confirmed,
			};
			item.StartTime = calendar.Date;
			item.EndTime = item.StartTime.AddHours(0.5);
			calendar.Schedule.Items.Add(item);

			item = new CustomItem()
			{
				Auth = Colors.Green,
				Site = "C017",
				Patient = "Clinton, Franklin",
				Drug = "Ertapenem 500mg x2 doses weekly",
				Qty = 2,
				Type = DataType.Refill,
				Status = DataStatus.Confirmed,
				HasAttachment = true,
				HasPrescription = true,
			};
			item.StartTime = calendar.Date.AddHours(0.5);
			item.EndTime = item.StartTime.AddHours(0.5);
			calendar.Schedule.Items.Add(item);

			item = new CustomItem()
			{
				Auth = Colors.Orange,
				Site = "C017",
				Patient = "Phillips, Trevor",
				Drug = "Ceftriaxone 2mg q24h x4 days",
				Qty = 4,
				Type = DataType.Refill,
				Status = DataStatus.Confirmed,
				HasAttachment = true,
				HasPrescription = true,
			};
			item.StartTime = calendar.Date.AddHours(1);
			item.EndTime = item.StartTime.AddHours(0.5);
			calendar.Schedule.Items.Add(item);

			item = new CustomItem()
			{
				Auth = Colors.Green,
				Site = "C017",
				Patient = "Johnson, Carl",
				Drug = "Daptomycin 350mg q24h x7 days",
				Qty = 7,
				Type = DataType.New,
				Status = DataStatus.Cancelled,
			};
			item.StartTime = calendar.Date.AddHours(1.5);
			item.EndTime = item.StartTime.AddHours(0.5);
			calendar.Schedule.Items.Add(item);

			item = new CustomItem()
			{
				Auth = Colors.Green,
				Site = "C018",
				Patient = "Speed, Claude",
				Drug = "Daptomycin 750mg q24h x7 days",
				Qty = 7,
				Type = DataType.Refill,
				Status = DataStatus.Confirmed,
				HasAttachment = true,
			};
			item.StartTime = calendar.Date.AddHours(2);
			item.EndTime = item.StartTime.AddHours(0.5);
			calendar.Schedule.Items.Add(item);

			item = new CustomItem()
			{
				Auth = Colors.Green,
				Site = "C018",
				Patient = "Lawson, Miranda",
				Drug = "Vancomycin 1800mg q12h x7 days",
				Qty = 14,
				Type = DataType.Extend,
				Status = DataStatus.Rescheduled,
			};
			item.StartTime = calendar.Date.AddHours(2.5);
			item.EndTime = item.StartTime.AddHours(0.5);
			calendar.Schedule.Items.Add(item);

			item = new CustomItem()
			{
				Auth = Colors.Green,
				Site = "C018",
				Patient = "Taylor, Jacob",
				Drug = "Invanz 1g q24h x4 days",
				Qty = 4,
				Type = DataType.ChangeSch,
				Status = DataStatus.Confirmed,
				HasAttachment = true,
				HasPrescription = true,
			};
			item.StartTime = calendar.Date.AddHours(3);
			item.EndTime = item.StartTime.AddHours(0.5);
			calendar.Schedule.Items.Add(item);
		}

		private void CanBrowseBack(object sender, CanExecuteRoutedEventArgs e)
		{
			e.CanExecute = true;
		}

		private void OnBrowseBack(object sender, ExecutedRoutedEventArgs e)
		{
			calendar.Date = calendar.Date.AddMonths(-1);
			calendar.EndDate = calendar.Date.AddMonths(2);
		}

		private void CanBrowseForward(object sender, CanExecuteRoutedEventArgs e)
		{
			e.CanExecute = true;
		}

		private void OnBrowseForward(object sender, ExecutedRoutedEventArgs e)
		{
			calendar.Date = calendar.Date.AddMonths(1);
			calendar.EndDate = calendar.Date.AddMonths(2);
		}
	}
}
